--FUNÇÕES
-----------------------------------------------------------------------------------------------------------------------------------
function existeArquivo(file)
  local f = io.open(file, "r")
  if f then f:close() end
  return f ~= nil
end
-----------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------
function lerLinhas(file)
  if not existeArquivo(file) then return {} end
  lines = {}
  for line in io.lines(file) do 
    lines[#lines + 1] = line
  end
  return lines
end
-----------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------
function separar(inputstr, sep)
        if sep == nil then
                sep = "%s"
        end
        local t={} ; i=1
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                t[i] = str
                i = i + 1
        end
        return t
end
-----------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------
function imprimirCliente(cliente)
    print(cliente["Código"])
    print(cliente["Nome"])
    print(cliente["Endereço"])
    print(cliente["Telefone"])
    print(cliente["Data de cadastro"])
    print(cliente["Tipo de cliente"])
    print(cliente["CPF/CNPJ"])
    print(cliente["Inscrição estadual"])
    print()
end
-----------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------
function imprimirFornecedor(fornecedor)
    print(fornecedor["Código"])
    print(fornecedor["Nome"])
    print(fornecedor["Endereço"])
    print(fornecedor["Telefone"])
    print(fornecedor["CNPJ"])
    print(fornecedor["Pessoa de contato"])
    print()
end
-----------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------
function imprimirProduto(produto)
    print(produto["Código"])
    print(produto["Descrição"])
    print(produto["Estoque mínimo"])
    print(produto["Estoque atual"])
    print(produto["Valor de custo"])
    print(produto["Percentual de lucro"])
    print()
end
-----------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------
function imprimirCompra(compra)
    print(compra["Nota fiscal"])
    print(compra["Fornecedor"])
    print(compra["Data da compra"])
    print(compra["Produto"])
    print(compra["Quantidade"])
    print()
end
-----------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------
function imprimirVenda(venda)
    print(venda["Cliente"])
    print(venda["Data de venda"])
    print(venda["Produto"])
    print(venda["Quantidade"])
    print(venda["Modo de pagamento"])
    print()
end
-----------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------
function criaTabela(table)
	tabela = {}
	for k, v in pairs(table) do
		tabela[table[k]["Código"]] = 0
	end
	return tabela
end
-----------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------
function converteReal(tabela)
	local temp = {}
	for k, v in pairs(tabela) do
		temp[k] = {}
		temp[k] = "R$ " .. v
		i = i + 1
	end
	return temp
end
-----------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------
function criaArquivo(arquivo, linhas)
	local escrever = io.open(arquivo, "w")
	io.output(escrever)
	io.write(linhas[1]) io.write("\n")
	table.remove(linhas, 1)
	table.sort(linhas)
	for k,v in pairs(linhas) do
	  io.write(v) io.write("\n")
	end
	io.close(escrever)
end
-----------------------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------------------	
function lerArquivo(arquivo)
	local lines = lerLinhas(arquivo)
	local auxiliar = {}
	local table = {}
	if arquivo == "vendas.csv" then
		for k, v in pairs(lines) do
			if k == 1 then
				auxiliar = separar(v, ";")
			else
				table[k-1] = {}
				local dados = separar(v, ";")
				local i = 1
				while dados[i] ~= nil do
					if string.len(dados[1]) > 8 
						then
							table[k-1][auxiliar[i+1]] = dados[i]
						else
							table[k-1][auxiliar[i]] = dados[i]
					end
					i = i + 1
				end
			end
		end
	else
		for k, v in pairs(lines) do
			if k == 1 then
				auxiliar = separar(v, ";")
			else
				table[k-1] = {}
				local dados = separar(v, ";")
				local i = 1
				while dados[i] ~= nil do
					table[k-1][auxiliar[i]] = dados[i]
					i = i + 1
				end
			end
		end
	end
	return table
end
-----------------------------------------------------------------------------------------------------------------------------------

