#!/usr/bin/lua
require "Classes.Pessoa"
require "Classes.Cliente"
require "Classes.ClienteFisico"
require "Classes.ClienteJuridico"
require "Classes.Fornecedor"
require "funcoes"


assert(os.setlocale("pt_BR.utf8"))

--CÓDIGO
--Lê os arquivos de entrada, criando tables com cada uma delas.
local clientes = lerArquivo(arg[2])
local fornecedores = lerArquivo(arg[4])
local produtos = lerArquivo(arg[6])
local compras = lerArquivo(arg[8])
local vendas = lerArquivo(arg[10])

--Cria relatório que o Senhor Oak deverá pagar aos fornecedores
local apagar = criaTabela(fornecedores)

--Pra cada compra, varre a table de produtos, acrescentando o valor do produto * quantidade a ser pago ao fornecedor
for k, v in pairs(compras) do
	for a, b in pairs(produtos) do
		if v["Produto"] == b["Código"] then
			apagar[v["Fornecedor"]] = apagar[v["Fornecedor"]] + v["Quantidade"]*(b["Valor de custo"])
		end
	end
end

apagar = converteReal(apagar)

--Formata o arquivo de saida apagar.csv
local linhasapagar = {}
linhasapagar[1] = "Fornecedor;CNPJ;Pessoa de contato;Telefone;Total a pagar"
for k, v in pairs(fornecedores) do
	linhasapagar[k+1] = v["Nome"] .. ";" .. v["CNPJ"] .. ";" .. v["Pessoa de contato"] .. ";" .. v["Telefone"] .. ";" .. apagar[v["Código"]]
end

criaArquivo("apagar.csv", linhasapagar)

--Cria relatório que o Senhor Oak deverá pagar aos fornecedores
local areceber = criaTabela(clientes)

for k, v in pairs(vendas) do
	if v["Cliente"] ~= nil then
		for a, b in pairs(produtos) do
			if v["Produto"] == b["Código"] then
				areceber[v["Cliente"]] = areceber[v["Cliente"]] + v["Quantidade"]*(b["Valor de custo"]*(1+b["Percentual de lucro"]/100))
			end
		end
	end
end

areceber = converteReal(areceber)

--Formata o arquivo de saida areceber.csv
local linhasareceber = {}
linhasareceber[1] = "Nome;Tipo;CPF/CNPJ;Telefone;Data de cadastro;Total a pagar"
for k, v in pairs(clientes) do
	linhasareceber[k+1] = v["Nome"] .. ";" .. v["Tipo de cliente"] .. ";" .. v["CPF/CNPJ"] .. ";" .. v["Telefone"] .. ";" .. v["Data de cadastro"] .. ";" .. areceber[v["Código"]]
end

criaArquivo("areceber.csv", linhasareceber)
-----------------------------------------------------------------------------------------------------------------------------------






















		





















--[[
print("\n\n\n\n-----------------LISTA DE CLIENTES-----------------")
for k, v in pairs(clientes) do
	imprimirCliente(clientes[k])
end

print("\n\n\n\n-----------------LISTA DE FORNECEDORES-----------------")
for k, v in pairs(fornecedores) do
	imprimirFornecedor(fornecedores[k])
end

print("\n\n\n\n-----------------LISTA DE PRODUTOS-----------------")
for k, v in pairs(produtos) do
	imprimirProduto(produtos[k])
end

print("\n\n\n\n-----------------LISTA DE COMPRAS-----------------")
for k, v in pairs(compras) do
	imprimirCompra(compras[k])
end

print("\n\n\n\n-----------------LISTA DE VENDAS-----------------")
for k, v in pairs(vendas) do
	imprimirVenda(vendas[k])
end
--]]


